/*

  Nullsoft WASABI Source File License

  Copyright 1999-2001 Nullsoft, Inc.

    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


  Brennan Underwood
  brennan@nullsoft.com

*/

/* copyright (C) 2002 HOSHINO Yoshifumi (Yoshi) */


#ifndef _GENERICWND_H
#define _GENERICWND_H

#include "c:/Wasabi SDK/studio/bfc/virtualwnd.h"
#include "c:/Wasabi SDK/studio/bfc/wnds/buttwnd.h"
#include "c:/Wasabi SDK/studio/common/nsGUID.h"

#include "c:/Wasabi SDK/studio/studio/corecb.h"

#include "myCore.h"
#include "../cmdprovider.h"

#define GENERICWND_PARENT VirtualWnd

class GenericWnd : public GENERICWND_PARENT, public CoreCallbackI {
public:
  GenericWnd();
  ~GenericWnd();
  CMyCoreHandle *pCore;

  // =========================================================================
  //
  //  Methods required by Window Creation Services
  //
  static const char *getWindowTypeName();
  static GUID getWindowTypeGuid();
  static void setIconBitmaps(ButtonWnd *button);    

  // =========================================================================
  //
  //
  virtual int onInit();
  virtual int onPaint(Canvas *canvas);

  virtual void timerCallback(int id);

  virtual int corecb_onTitleChange(const char *title);

  char m_szTitle[1024];
  char m_szArtist[1024];
  
private:
  CommandProvider *pCmdProv;

protected:


};

#endif _GENERICWND_H
